IMPLEMENTATION MODULE MCL68882;
FROM  MC68882 IMPORT floatflag;
FROM SYSTEM IMPORT BYTE,REGISTER,ADR,SETREG,CODE,ADDRESS,LONGWORD;
FROM TextIO IMPORT WriteInt,WriteLn,Read,WriteString,WriteReal,WriteHexAdr,
      WriteHex,Write;
FROM Conversions IMPORT ConvertToString, ConvertFromString;
FROM InOut IMPORT ReadString, WriteStringRight;
FROM LongMathLib0 IMPORT longreal,dentier,dpi,dsin,dcos,dtan,darcsin,darccos,   darctan,dexp,dln,dlog,dsqrt,dpower;
FROM LongInOut IMPORT WriteLongInt,WriteLongHex;
FROM RealInOut IMPORT WriteLongReal;
FROM LongHyperMathLib IMPORT dsinh,dcosh,dtanh,darcsinh,darccosh,darctanh;

CONST FNOP=0F280H;REALOP=04400H;LINTOP=04000H;DREALOP=04800H;
      F68882=0F200H; DADR=018H; 
      FABS=18H;  FACOS=1CH; FASIN=0CH;  FATAN= 0AH;  FATANH = 0DH;
      FCOS=01DH; FSIN=00EH; FTAN=00FH;
      FMOVECR = 0F200H;
      FADD=022H; FDIV= 020H; FMUL=023H; FSUB=028H;
      FSINH=02H; FSQRT=04H; FTANH = 09H; FLOGN=14H; FLOG10=15H;
      FLOG2=16H; FCOSH=19H; FNEG=1AH; FMOD=021H; 
      FTENTOX=3H;FTWOTOX=3H;FETOX=35;
      IndirectA=10H;

VAR 
 
 result,des:ARRAY[0..55] OF CHAR;
   c12:CHAR;
   x,z:LONGREAL;
   x1:LONGREAL;
   p: CARDINAL;
   y:RECORD
     CASE type : BOOLEAN OF
       TRUE : lr:LONGREAL; |
       FALSE : hi,lo,jk : LONGCARD
     END;
   END;

PROCEDURE Lfloatx(x:LONGWORD):LONGREAL;
VAR 
    y2:POINTER TO LONGREAL;
    y5:POINTER TO LONGWORD;
    m:LONGWORD;
BEGIN
      m:=x;y5:=ADR(m);
   IF INTEGER(floatflag)= 2 THEN
      SETREG(10,y5);
      CODE (0F200H+IndirectA +2 );CODE(4000H); 
      y2:=ADR(y.lr);SETREG(10,y2);
      CODE (0F200H+IndirectA +2 );CODE(6800H); 
    END;
      RETURN(y.lr);
END Lfloatx;

PROCEDURE Lengthen(x:REAL):LONGREAL;
VAR 
    y2:POINTER TO LONGREAL;
    y5:POINTER TO REAL;
    m:REAL;
BEGIN
      m:=x;y5:=ADR(m);
   IF INTEGER(floatflag)= 2 THEN
      SETREG(10,y5);
      CODE (0F200H+IndirectA +2 );CODE(4400H); 
      y2:=ADR(y.lr);SETREG(10,y2);
      CODE (0F200H+IndirectA +2 );CODE(6800H); 
    END;
      RETURN(y.lr);
END Lengthen;

PROCEDURE Shorten(x:LONGREAL):REAL;
VAR 
    y2:POINTER TO LONGREAL;
    y5:POINTER TO REAL;
    m:REAL;
BEGIN
      m:=x;y5:=ADR(m);
   IF INTEGER(floatflag)= 2 THEN
      SETREG(10,y5);
      CODE (0F200H+IndirectA +2 );CODE(4800H); 
      CODE (0F200H,6400H);
      RETURN REAL(REGISTER(0)); 
   END;
      RETURN(y.lr);
END Shorten;

PROCEDURE LFneg(a:LONGREAL):LONGREAL;
VAR 
    y2:POINTER TO LONGREAL;
    x:LONGREAL;
BEGIN
   IF INTEGER(floatflag)= 2 THEN
      x:=a;y2:=ADR(x);   SETREG(10,y2);
      CODE (0F200H+IndirectA +2 );CODE(4800H); 
      CODE(F68882);CODE(001AH);      (* NEG  *)
      y2:=ADR(y.lr);SETREG(10,y2);
      CODE (0F200H+IndirectA +2 );CODE(6800H); 
      RETURN y.lr;
    ELSE
      RETURN -a;
    END;
END LFneg;

PROCEDURE LFlog10(VAR a:LONGREAL):LONGREAL;
VAR 
    y2:POINTER TO LONGREAL;
    x:LONGREAL;
BEGIN
   IF INTEGER(floatflag)= 2 THEN
      x:=a;y2:=ADR(x);  SETREG(10,y2);
      CODE (0F200H+IndirectA +2 );CODE(4800H); 
      CODE(F68882);CODE(FLOG10);  
      y2:=ADR(y.lr);SETREG(10,y2);
      CODE (0F200H+IndirectA +2 );CODE(6800H); 
      RETURN y.lr;
    ELSE
      RETURN dlog(a);
    END;
END LFlog10;

PROCEDURE LFlogn(VAR a:LONGREAL):LONGREAL;
VAR 
    y2:POINTER TO LONGREAL;
    x:LONGREAL;
BEGIN
   IF INTEGER(floatflag)= 2 THEN
      x:=a;y2:=ADR(x);  SETREG(10,y2);
      CODE (0F200H+IndirectA +2 );CODE(4800H); 
      CODE(F68882);CODE(FLOGN);  
      y2:=ADR(y.lr);SETREG(10,y2);
      CODE (0F200H+IndirectA +2 );CODE(6800H); 
      RETURN y.lr;
    ELSE
      RETURN dln(a);
    END;
END LFlogn;

PROCEDURE LFtanh(VAR a:LONGREAL):LONGREAL;
VAR 
    y2:POINTER TO LONGREAL;
    x:LONGREAL;
BEGIN
   IF INTEGER(floatflag)= 2 THEN
      x:=a;y2:=ADR(x);  SETREG(10,y2);
      CODE (0F200H+IndirectA +2 );CODE(4800H); 
      CODE(F68882);CODE(FTANH);  
      y2:=ADR(y.lr);SETREG(10,y2);
      CODE (0F200H+IndirectA +2 );CODE(6800H); 
      RETURN y.lr;
    ELSE
      RETURN dtanh(a);
    END;
END LFtanh;

PROCEDURE LFcosh(VAR a:LONGREAL):LONGREAL;
VAR 
    y2:POINTER TO LONGREAL;
    x:LONGREAL;
BEGIN
   IF INTEGER(floatflag)= 2 THEN
      x:=a;y2:=ADR(x);  SETREG(10,y2);
      CODE (0F200H+IndirectA +2 );CODE(4800H); 
      CODE(F68882);CODE(FCOSH);  
      y2:=ADR(y.lr);SETREG(10,y2);
      CODE (0F200H+IndirectA +2 );CODE(6800H); 
      RETURN y.lr;
    ELSE
      RETURN dcosh(a);
    END;
END LFcosh;

PROCEDURE LFsinh(VAR a:LONGREAL):LONGREAL;
VAR 
    y2:POINTER TO LONGREAL;
    x:LONGREAL;
BEGIN
   IF INTEGER(floatflag)= 2 THEN
      x:=a;y2:=ADR(x);  SETREG(10,y2);
      CODE (0F200H+IndirectA +2 );CODE(4800H); 
      CODE(F68882);CODE(FSINH);  
      y2:=ADR(y.lr);SETREG(10,y2);
      CODE (0F200H+IndirectA +2 );CODE(6800H); 
      RETURN y.lr;
    ELSE
      RETURN dsinh(a);
    END;
END LFsinh;

PROCEDURE LFatanh(VAR a:LONGREAL):LONGREAL;
VAR 
    y2:POINTER TO LONGREAL;
    x:LONGREAL;
BEGIN
   IF INTEGER(floatflag)= 2 THEN
      x:=a;y2:=ADR(x);  SETREG(10,y2);
      CODE (0F200H+IndirectA +2 );CODE(4800H); 
      CODE(F68882);CODE(FATANH);  
      y2:=ADR(y.lr);SETREG(10,y2);
      CODE (0F200H+IndirectA +2 );CODE(6800H); 
      RETURN y.lr;
    ELSE
      RETURN darctanh(a);
    END;
END LFatanh;

PROCEDURE LFtan(VAR a:LONGREAL):LONGREAL;
VAR 
    y2:POINTER TO LONGREAL;
    x:LONGREAL;
BEGIN
   IF INTEGER(floatflag)= 2 THEN
      x:=a;y2:=ADR(x);  SETREG(10,y2);
      CODE (0F200H+IndirectA +2 );CODE(4800H); 
      CODE(F68882);CODE(FTAN);  
      y2:=ADR(y.lr);SETREG(10,y2);
      CODE (0F200H+IndirectA +2 );CODE(6800H); 
      RETURN y.lr;
    ELSE
      RETURN dtan(a);
    END;
END LFtan;

PROCEDURE LFsin(VAR a:LONGREAL):LONGREAL;
VAR 
    y2:POINTER TO LONGREAL;
    x:LONGREAL;
BEGIN
   IF INTEGER(floatflag)= 2 THEN
      x:=a;y2:=ADR(x);  SETREG(10,y2);
      CODE (0F200H+IndirectA +2 );CODE(4800H); 
      CODE(F68882);CODE(FSIN);  
      y2:=ADR(y.lr);SETREG(10,y2);
      CODE (0F200H+IndirectA +2 );CODE(6800H); 
      RETURN y.lr;
    ELSE
      RETURN dsin(a);
    END;
END LFsin;

PROCEDURE LFcos(VAR a:LONGREAL):LONGREAL;
VAR 
    y2:POINTER TO LONGREAL;
    x:LONGREAL;
BEGIN
   IF INTEGER(floatflag)= 2 THEN
      x:=a;y2:=ADR(x);  SETREG(10,y2);
      CODE (0F200H+IndirectA +2 );CODE(4800H); 
      CODE(F68882);CODE(FCOS);  
      y2:=ADR(y.lr);SETREG(10,y2);
      CODE (0F200H+IndirectA +2 );CODE(6800H); 
      RETURN y.lr;
    ELSE
      RETURN dcos(a);
    END;
END LFcos;

PROCEDURE LFasin(VAR a:LONGREAL):LONGREAL;
VAR 
    y2:POINTER TO LONGREAL;
    x:LONGREAL;
BEGIN
   IF INTEGER(floatflag)= 2 THEN
      x:=a;y2:=ADR(x);  SETREG(10,y2);
      CODE (0F200H+IndirectA +2 );CODE(4800H); 
      CODE(F68882);CODE(FASIN);  
      y2:=ADR(y.lr);SETREG(10,y2);
      CODE (0F200H+IndirectA +2 );CODE(6800H); 
      RETURN y.lr;
    ELSE
      RETURN darcsin(a);
    END;
END LFasin;

PROCEDURE LFacos(VAR a:LONGREAL):LONGREAL;
VAR 
    y2:POINTER TO LONGREAL;
    x:LONGREAL;
BEGIN
   IF INTEGER(floatflag)= 2 THEN
      x:=a;y2:=ADR(x);  SETREG(10,y2);
      CODE (0F200H+IndirectA +2 );CODE(4800H); 
      CODE(F68882);CODE(FACOS);  
      y2:=ADR(y.lr);SETREG(10,y2);
      CODE (0F200H+IndirectA +2 );CODE(6800H); 
      RETURN y.lr;
    ELSE
      RETURN darccos(a);
    END;
END LFacos;

PROCEDURE LFlog2(VAR a:LONGREAL):LONGREAL;
VAR 
    y2:POINTER TO LONGREAL;
    x:LONGREAL;
BEGIN
   IF INTEGER(floatflag)= 2 THEN
      x:=a;y2:=ADR(x);  SETREG(10,y2);
      CODE (0F200H+IndirectA +2 );CODE(4800H); 
      CODE(F68882);CODE(FLOG2);  
      y2:=ADR(y.lr);SETREG(10,y2);
      CODE (0F200H+IndirectA +2 );CODE(6800H); 
      RETURN y.lr;
    ELSE
      RETURN dln(a)/dln(2.0);
    END;
END LFlog2;

PROCEDURE LFsqrt(VAR a:LONGREAL):LONGREAL;
VAR 
    y2:POINTER TO LONGREAL;
    x:LONGREAL;
BEGIN
   IF INTEGER(floatflag)= 2 THEN
      x:=a;y2:=ADR(x);
      SETREG(10,y2);
      CODE (0F200H+IndirectA +2 );CODE(4800H); 
      CODE(F68882);CODE(FSQRT);      (* Sqrt  *)
      y2:=ADR(y.lr);SETREG(10,y2);
      CODE (0F200H+IndirectA +2 );CODE(6800H); 
      RETURN y.lr;
    ELSE
      RETURN dsqrt(a);
    END;
END LFsqrt;

PROCEDURE LFsub(VAR a,b:LONGREAL):LONGREAL;
VAR 
    y2:POINTER TO LONGREAL;
    x:LONGREAL;
BEGIN
   IF INTEGER(floatflag)= 2 THEN
      x:=a;y2:=ADR(x);   SETREG(10,y2);
      CODE (0F200H+IndirectA +2 );CODE(4800H); 
      x:=b;y2:=ADR(x);   SETREG(10,y2);
      CODE(F68882+IndirectA+2);CODE(04800H+FSUB);      
      y2:=ADR(y.lr);SETREG(10,y2);
      CODE (0F200H+IndirectA +2 );CODE(6800H); 
      RETURN y.lr;
    ELSE
      RETURN (a-b);
    END;
END LFsub;

PROCEDURE LFmul(VAR a,b:LONGREAL):LONGREAL;
VAR 
    y2:POINTER TO LONGREAL;
    x:LONGREAL;
BEGIN
   IF INTEGER(floatflag)= 2 THEN
      x:=a;y2:=ADR(x);   SETREG(10,y2);
      CODE (0F200H+IndirectA +2 );CODE(4800H); 
      x:=b;y2:=ADR(x);   SETREG(10,y2);
      CODE(F68882+IndirectA+2);CODE(04800H+FMUL);      
      y2:=ADR(y.lr);SETREG(10,y2);
      CODE (0F200H+IndirectA +2 );CODE(6800H); 
      RETURN y.lr;
    ELSE
      RETURN (a*b);
    END;
END LFmul;

PROCEDURE LFadd(VAR a,b:LONGREAL):LONGREAL;
VAR 
    y2:POINTER TO LONGREAL;
    x:LONGREAL;
BEGIN
   IF INTEGER(floatflag)= 2 THEN
      x:=a;y2:=ADR(x);   SETREG(10,y2);
      CODE (0F200H+IndirectA +2 );CODE(4800H); 
      x:=b;y2:=ADR(x);   SETREG(10,y2);
      CODE(F68882+IndirectA+2);CODE(04800H+FADD);      
      y2:=ADR(y.lr);SETREG(10,y2);
      CODE (0F200H+IndirectA +2 );CODE(6800H); 
      RETURN y.lr;
    ELSE
      RETURN (a+b);
    END;
END LFadd;

PROCEDURE LFmod(VAR a,b:LONGREAL):LONGREAL;
VAR 
    y2:POINTER TO LONGREAL;
    x:LONGREAL;
BEGIN
   IF b= DFZero() THEN RETURN 1000000.0;END;  
   IF INTEGER(floatflag)= 2 THEN
      x:=a;y2:=ADR(x);   SETREG(10,y2);
      CODE (0F200H+IndirectA +2 );CODE(4800H); 
      x:=b;y2:=ADR(x);   SETREG(10,y2);
      CODE(F68882+IndirectA+2);CODE(04800H+FMOD); 
      y2:=ADR(y.lr);SETREG(10,y2);
      CODE (0F200H+IndirectA +2 );CODE(6800H); 
      RETURN y.lr;
    ELSE
      RETURN (a/b);
    END;
END LFmod;

PROCEDURE LFdiv(VAR a,b:LONGREAL):LONGREAL;
VAR 
    y2:POINTER TO LONGREAL;
    x:LONGREAL;
BEGIN
   IF b= DFZero() THEN RETURN 1000000.0;END;  
   IF INTEGER(floatflag)= 2 THEN
      x:=a;y2:=ADR(x);   SETREG(10,y2);
      CODE (0F200H+IndirectA +2 );CODE(4800H); 
      x:=b;y2:=ADR(x);   SETREG(10,y2);
      CODE(F68882+IndirectA+2);CODE(04800H+FDIV);      (* DIV  *)
      y2:=ADR(y.lr);SETREG(10,y2);
      CODE (0F200H+IndirectA +2 );CODE(6800H); 
      RETURN y.lr;
    ELSE
      RETURN (a/b);
    END;
END LFdiv;

PROCEDURE DFZero():LONGREAL;
VAR 
    y2:POINTER TO LONGREAL;
BEGIN
   IF INTEGER(floatflag)= 2 THEN
      CODE(FMOVECR);CODE(05C0FH);
      y2:=ADR(y.lr);SETREG(10,y2);
      CODE (0F200H+IndirectA +2 );CODE(6800H); 
      RETURN y.lr;
    ELSE
       RETURN 0.00;
    END;
END DFZero;

PROCEDURE DFe():LONGREAL;
VAR 
    y2:POINTER TO LONGREAL;
BEGIN
   IF INTEGER(floatflag)= 2 THEN
      CODE(FMOVECR);CODE(05C0cH);
      y2:=ADR(y.lr);SETREG(10,y2);
      CODE (0F200H+IndirectA +2 );CODE(6800H); 
      RETURN y.lr;
    ELSE
       RETURN 2.78;
    END;
END DFe;

PROCEDURE DFpi():LONGREAL;
VAR 
    y2:POINTER TO LONGREAL;
BEGIN
   IF INTEGER(floatflag)= 2 THEN
      CODE(FMOVECR);CODE(05C00H);
      y2:=ADR(y.lr);SETREG(10,y2);
      CODE (0F200H+IndirectA +2 );CODE(6800H); 
      RETURN y.lr;
      ELSE RETURN 3.14159;
    END;
END DFpi;

PROCEDURE PrintLongReal(a:LONGREAL;b:CARDINAL);
VAR k:ARRAY [0..25] OF CHAR;
    i:CARDINAL;
BEGIN
   Convert(a);
   IF b>25 THEN WriteString(des);RETURN;END;
   IF b<8 THEN b:=8;END;
   FOR i:=0 TO b-5 DO
      k[i]:=des[i];
   END;
   FOR i:=0 TO 7 DO
      k[b-4+i]:=des[19+i];
   END;
   k[b]:=0C;
   WriteString(k);
   WriteString(des);Wait;
END PrintLongReal;

PROCEDURE Convert(a:LONGREAL);
VAR 
    y2:POINTER TO LONGREAL;
    str,b:ARRAY[0..55] OF CHAR;
    y4:POINTER TO CHAR;
    m:LONGREAL;
    i:INTEGER;
BEGIN
      FOR i:=0 TO 35 DO str[i]:=0C;END;
   IF INTEGER(floatflag)= 2 THEN
      m:=a;y2:=ADR(m);   SETREG(10,y2);
      CODE (0F200H+IndirectA +2 );CODE(4800H); 
      y4:=ADR(str); SETREG(10,y4);
      CODE (0F200H+IndirectA +2 );CODE(6C4FH); 
      ChangeBCDtoString(str);
    END;
END Convert;

PROCEDURE ChangeBCDtoString(VAR a:ARRAY OF CHAR);
VAR i,j,spot:INTEGER;
BEGIN
   spot:=0;des:="                      ";
   IF ORD(a[0])>7fH THEN des[spot]:="-";
   ELSE des[spot]:=" ";
   END; INC(spot);
   j:=ORD(a[3]) MOD 10H;des[spot]:=CHAR(j+48);INC(spot);
   des[spot]:=".";INC(spot);
   FOR i:=4 TO 11 DO
      j:=ORD(a[i]) DIV 10H;des[spot]:=CHAR(j+48);INC(spot);
      j:=ORD(a[i]) MOD 10H;des[spot]:=CHAR(j+48);INC(spot);
   END;
   des[spot]:="E";INC(spot);
   j:=ORD(a[0]) MOD 80H;
   IF j>3fH THEN  des[spot]:="-";
   ELSE des[spot]:="+";
   END;INC(spot);
   j:=ORD(a[0]) MOD 10H;des[spot]:=CHAR(j+48);INC(spot);
   j:=ORD(a[1]) DIV 10H;des[spot]:=CHAR(j+48);INC(spot);
   j:=ORD(a[1]) MOD 10H;des[spot]:=CHAR(j+48);INC(spot);
   des[spot]:=0C;
(*   WriteString(des);WriteLn;Wait;*)
   result:=des;  
END ChangeBCDtoString;

PROCEDURE Wait;
BEGIN Read(c12);END Wait;

END MCL68882.




